<?xml version="1.0" encoding="UTF-8"?>
<!--These rules are for informational purposes only and DO NOT supersede the requirements in NIST SP 800-126 Rev 2.-->
<!--These rules may be revised at anytime. Comments/feedback on these rules are welcome.-->
<!--Private comments may be sent to scap@nist.gov.  Public comments may be sent to scap-dev@nist.gov.-->
<sch:schema xmlns:sch="http://purl.oclc.org/dsdl/schematron" queryBinding="xslt2">
  <sch:ns prefix="ai" uri="http://scap.nist.gov/schema/asset-identification/1.1"/>
  <sch:ns prefix="arf"
           uri="http://scap.nist.gov/schema/asset-reporting-format/1.1"/>
  <sch:ns prefix="cat" uri="urn:oasis:names:tc:entity:xmlns:xml:catalog"/>
  <sch:ns prefix="cpe-dict" uri="http://cpe.mitre.org/dictionary/2.0"/>
  <sch:ns prefix="cpe-lang" uri="http://cpe.mitre.org/language/2.0"/>
  <sch:ns prefix="dc" uri="http://purl.org/dc/elements/1.1/"/>
  <sch:ns prefix="ds" uri="http://scap.nist.gov/schema/scap/source/1.2"/>
  <sch:ns prefix="dsig" uri="http://www.w3.org/2000/09/xmldsig#"/>
  <sch:ns prefix="java" uri="java:gov.nist.scap.schematron"/>
  <sch:ns prefix="nvd-config"
           uri="http://scap.nist.gov/schema/feed/configuration/0.1"/>
  <sch:ns prefix="ocil" uri="http://scap.nist.gov/schema/ocil/2.0"/>
  <sch:ns prefix="oval-com" uri="http://oval.mitre.org/XMLSchema/oval-common-5"/>
  <sch:ns prefix="oval-def"
           uri="http://oval.mitre.org/XMLSchema/oval-definitions-5"/>
  <sch:ns prefix="oval-res" uri="http://oval.mitre.org/XMLSchema/oval-results-5"/>
  <sch:ns prefix="oval-sc"
           uri="http://oval.mitre.org/XMLSchema/oval-system-characteristics-5"/>
  <sch:ns prefix="rc" uri="http://scap.nist.gov/schema/reporting-core/1.1"/>
  <sch:ns prefix="scap" uri="http://scap.nist.gov/schema/scap/source/1.2"/>
  <sch:ns prefix="scap-con" uri="http://scap.nist.gov/schema/scap/constructs/1.2"/>
  <sch:ns prefix="tmsad" uri="http://scap.nist.gov/schema/xml-dsig/1.0"/>
  <sch:ns prefix="xccdf" uri="http://checklists.nist.gov/xccdf/1.2"/>
  <sch:ns prefix="xcf" uri="nist:scap:xslt:function"/>
  <sch:ns prefix="xinclude" uri="http://www.w3.org/2001/XInclude"/>
  <sch:ns prefix="xlink" uri="http://www.w3.org/1999/xlink"/>
  <sch:ns prefix="xml" uri="http://www.w3.org/XML/1998/namespace"/>
  <sch:ns prefix="xsd" uri="http://www.w3.org/2001/XMLSchema"/>
  <sch:pattern id="scap-result-general">
      <sch:rule id="scap-result-general-xccdf-rule-result" context="xccdf:rule-result">
         <sch:assert id="scap-result-general-xccdf-rule-ident"
                     test="if (current()/ancestor::arf:asset-report-collection//xccdf:Rule[@id eq current()/@idref]/xccdf:ident/@system = 'http://cce.mitre.org' or current()/ancestor::arf:asset-report-collection//xccdf:Rule[@id eq current()/@idref]/xccdf:ident/@system = 'http://cpe.mitre.org' or current()/ancestor::arf:asset-report-collection//xccdf:Rule[@id eq current()/@idref]/xccdf:ident/@system = 'http://cve.mitre.org') then deep-equal(current()/xccdf:ident, current()/ancestor::arf:asset-report-collection//xccdf:Rule[@id eq current()/@idref]/xccdf:ident) else true()">If the target &lt;xccdf:Rule&gt; identified by the &lt;xccdf:rule-result idref=""&gt; attribute has one or more &lt;ident&gt; elements with the "http://cve.mitre.org" or "http://cpe.mitre.org" or "http://cpe.mitre.org" system identifier, then each &lt;xccdf:ident&gt; element SHALL also appear within the &lt;xccdf:rule-result&gt; element.|44-1</sch:assert>
        <sch:assert id="scap-result-xccdf-rule-result-result-val"
                     test="( ( (every $m in current()//xccdf:check satisfies if(count(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]) gt 1) then true() else if(not(exists(current()/xccdf:check/xccdf:check-content-ref/@name))) then true() else if(current()/xccdf:result eq 'error') then ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'error' else if( current()/xccdf:result eq 'unknown' ) then ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'unknown' else if(current()/@role eq 'unchecked') then current()/xccdf:result eq 'notchecked' else if( current()/xccdf:result eq 'notchecked' ) then ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'not evaluated' else if((current()/xccdf:result eq 'fail' and (current()/xccdf:check[@negate eq 'false'] or not(exists(current()/xccdf:check/@negate)))) or ((current()/xccdf:result eq 'pass' or current()/xccdf:result eq 'fixed' )and (current()/xccdf:check[@negate eq 'true']))) then ( ( ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'false' and ( matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(compliance|inventory)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(compliance|inventory)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class,'^(compliance|inventory)$') ) )  or ( ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'true' and ( matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(vulnerability|patch)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class[1],'^(vulnerability|patch)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class,'^(vulnerability|patch)$') ) ) ) else if(((current()/xccdf:result eq 'pass' or current()/xccdf:result eq 'fixed' )and (current()/xccdf:check[@negate eq 'false'] or not(exists(current()/xccdf:check/@negate)))) or (current()/xccdf:result eq 'fail' and (current()/xccdf:check[@negate eq 'true']))) then ( ( ( ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'true' ) and ( matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(compliance|inventory)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(compliance|inventory)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class,'^(compliance|inventory)$') ) ) or ( ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'false' and ( matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(vulnerability|patch)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(vulnerability|patch)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class,'^(vulnerability|patch)$') ) ) ) else if( current()/xccdf:result eq 'notselected' or current()/xccdf:result eq 'informational' or current()/xccdf:result eq 'notapplicable') then true() else false() ) and ( if(some $m in xccdf:complex-check/xccdf:check satisfies count(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]) gt 1 ) then true() else if( exists(current()/xccdf:complex-check[@operator eq 'AND'])) then ( if( current()/xccdf:result eq 'error' ) then some $m in xccdf:complex-check/xccdf:check satisfies ( ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'error' ) else if( current()/xccdf:result eq 'unknown' ) then some $m in xccdf:complex-check/xccdf:check satisfies (./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'unknown') else if(current()/@role eq 'unchecked') then current()/xccdf:result eq 'notchecked' else if(current()/xccdf:result eq 'notchecked') then some $m in xccdf:complex-check/xccdf:check satisfies (./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'not evaluated') else if((current()/xccdf:result eq 'fail' and (current()/xccdf:complex-check[@negate eq 'false'] or not(exists(current()/xccdf:complex-check/@negate)))) or ((current()/xccdf:result eq 'pass' or current()/xccdf:result eq 'fixed') and (current()/xccdf:complex-check[@negate eq 'true']))) then( (some $m in xccdf:complex-check/xccdf:check satisfies ( ((./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'false') or ($m[@negate eq 'true'] and ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'true') ) and ( matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(compliance|inventory)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(compliance|inventory)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class,'^(compliance|inventory)$') ) ) or ( ((./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'true') or ($m[@negate eq 'true'] and ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'false') ) and ( matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(vulnerability|patch)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(vulnerability|patch)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class,'^(vulnerability|patch)$') ) ) ) ) else if( ((current()/xccdf:result eq 'pass' or current()/xccdf:result eq 'fixed') and (current()/xccdf:complex-check[@negate eq 'false'] or not(exists(current()/xccdf:complex-check/@negate)))) or ((current()/xccdf:result eq 'pass' or current()/xccdf:result eq 'fixed')and (current()/xccdf:complex-check[@negate eq 'true']))) then( (every $m in xccdf:complex-check/xccdf:check satisfies ( ( ( ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'true') or ($m[@negate eq 'true'] and ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'false') ) and ( matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(compliance|inventory)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(compliance|inventory)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class,'^(compliance|inventory)$') ) ) or ( ((./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'false') or ($m[@negate eq 'true'] and ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'true') ) and ( matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(vulnerability|patch)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(vulnerability|patch)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class,'^(vulnerability|patch)$') ) ) ) ) else if( current()/xccdf:result eq 'notselected' or current()/xccdf:result eq 'informational' or current()/xccdf:result eq 'notapplicable') then (true()) else false() ) else true() ) and ( if(some $m in xccdf:complex-check/xccdf:check satisfies count(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]) gt 1 ) then true() else if( exists(current()/xccdf:complex-check[@operator eq 'OR'])) then ( if( current()/xccdf:result eq 'error' ) then some $m in xccdf:complex-check/xccdf:check satisfies (./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'error') else if( current()/xccdf:result eq 'unknown' ) then some $m in xccdf:complex-check/xccdf:check satisfies (./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'unknown') else if(current()/@role eq 'unchecked') then current()/xccdf:result eq 'notchecked' else if(current()/xccdf:result eq 'notchecked') then some $m in xccdf:complex-check/xccdf:check satisfies (./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'not evaluated') else if((current()/xccdf:result eq 'fail' and (current()/xccdf:complex-check[@negate eq 'false'] or not(exists(current()/xccdf:complex-check/@negate)))) or ((current()/xccdf:result eq 'pass' or current()/xccdf:result eq 'fixed')and (current()/xccdf:complex-check[@negate eq 'true']))) then( (every $m in xccdf:complex-check/xccdf:check satisfies ( ((./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'false') or($m[@negate eq 'true'] and ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'true') ) and ( matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(compliance|inventory)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(compliance|inventory)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class,'^(compliance|inventory)$') ) ) or ( ((./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'true') or($m[@negate eq 'true'] and ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'false') ) and ( matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(vulnerability|patch)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(vulnerability|patch)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class,'^(vulnerability|patch)$') ) ) ) ) else if(((current()/xccdf:result eq 'pass' or current()/xccdf:result eq 'fixed') and (current()/xccdf:complex-check[@negate eq 'false'] or not(exists(current()/xccdf:complex-check/@negate)))) or ((current()/xccdf:result eq 'pass' or current()/xccdf:result eq 'fixed') and (current()/xccdf:complex-check[@negate eq 'true']))) then( (some $m in xccdf:complex-check/xccdf:check satisfies ( ((./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'true') or($m[@negate eq 'true'] and ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'false')) and ( matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(compliance|inventory)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(compliance|inventory)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class,'^(compliance|inventory)$') ) ) or ( ((./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'false') or($m[@negate eq 'true'] and ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@result eq 'true') ) and ( matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(vulnerability|patch)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class,'^(vulnerability|patch)$') or matches(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class,'^(vulnerability|patch)$') ) ) ) ) else if( current()/xccdf:result eq 'notselected' or current()/xccdf:result eq 'informational' or current()/xccdf:result eq 'notapplicable') then (true()) else false() ) else true() ) ) or ( if (current()/xccdf:check/@system != 'http://oval.mitre.org/XMLSchema/oval-definitions-5') then true() else false() ) )">If the &lt;xccdf:result&gt; value for a &lt;xccdf:rule-result&gt; is 'error', 'unknown', 'notapplicable', or 'notchecked', then the result of at least one OVAL definition referenced by that rule SHALL be 'error', 'unknown', 'not applicable', or 'not evaluated', respectively.  If the &lt;xccdf:result&gt; value is 'fail' then the result of at least one of the OVAL definitions referenced SHALL match the fail category as defined in the SCAP table.  If the &lt;xccdf:result&gt; value is 'pass' then the result of all of the OVAL definitions referenced SHALL match the pass category as defined in the SCAP table.|126-1</sch:assert>
        <sch:assert id="scap-result-xccdf-rule-result-locate-oval-class-val"
                     test="( (every $m in current()//xccdf:check satisfies if(not( exists(current()/xccdf:check/xccdf:check-content-ref/@name))) then true() else exists(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class) or exists(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class) or exists(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class)) and (every $m in xccdf:complex-check/xccdf:check satisfies exists(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m/xccdf:check-content-ref[1]/@name]/@class) or exists(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/xccdf:check-content-ref[1]/@href]//oval-def:definition[@id eq $m/xccdf:check-content-ref[1]/@name]/@class) or exists(./ancestor::arf:asset-report-collection[1]//arf:report-request//oval-def:oval_definitions//oval-def:definition[@id eq $m//xccdf:check-content-ref[1]/@name][1]/@class)) ) or ( if (current()/xccdf:check/@system != 'http://oval.mitre.org/XMLSchema/oval-definitions-5') then true() else false() )">The @class attribute of an OVAL definition used in a check cannot be found. scapval may not be able to properly verify OVAL result to XCCDF result mapping. If you have the source content containing the OVAL definition, try the -source_ds option to include it.|126-2</sch:assert>
        <sch:assert id="scap-result-xccdf-rule-result-check-notapplicable"
                     test="( (every $m in current()//xccdf:check satisfies if(count(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]) gt 1) then true() else if(current()/xccdf:result eq 'notapplicable') then ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'not applicable' or ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'not evaluated' else true() ) and (every $m in xccdf:complex-check/xccdf:check satisfies if(count(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]) gt 1) then true() else if(current()/xccdf:result eq 'notapplicable') then ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'not applicable' or ./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]/@result eq 'not evaluated' else true() ) )">If the &lt;xccdf:result&gt; value for a &lt;xccdf:rule-result&gt; is 'notapplicable' and OVAL definitions apply, then the OVAL definition referenced by that rule is expected to be 'not applicable' or 'not evaluated'.|126-3</sch:assert>
        <sch:assert id="scap-result-xccdf-rule-result-multiple-oval-def"
                     test="( ( every $m in current()//xccdf:check satisfies if(count(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]) gt 1) then false() else true() ) and ( every $m in xccdf:complex-check/xccdf:check satisfies if(count(./ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m//xccdf:check-content-ref[1]/@href]//oval-res:definition[@definition_id eq $m//xccdf:check-content-ref[1]/@name]) gt 1) then false() else true() ) or ( if (current()/xccdf:check/@system != 'http://oval.mitre.org/XMLSchema/oval-definitions-5') then true() else false() ) )">If OVAL results component contain multiple instances of the same OVAL definition, SCAPVal cannot verify the mappings between OVAL results to XCCDF results.|126-4</sch:assert>
        <sch:assert id="scap-result-xccdf-rule-result-with-no-name"
                     test=" every $m in current()//xccdf:check satisfies ( if(not(exists($m/xccdf:check-content-ref/@name))) then count($m/ancestor::arf:asset-report-collection[1]/arf:report-requests//xccdf:Rule[@id eq $m/ancestor::node()/@idref]) eq 1 and not(exists($m/ancestor::arf:asset-report-collection[1]/arf:report-requests//xccdf:Rule[@id eq $m/ancestor::node()/@idref]/xccdf:check/xccdf:check-content-ref/@name)) and not(exists($m/ancestor::arf:asset-report-collection[1]/arf:report-requests//xccdf:Rule[@id eq $m/ancestor::node()/@idref]/xccdf:check[@multi-check eq 'true'])) else true() )">If &lt;xccdf:check-content-ref&gt; @name is not present, the &lt;xccdf:Rule&gt; referenced should also contain no @name reference and should not contain @multi-check="true".|126-5</sch:assert>
        <sch:assert id="scap-result-general-xccdf-rule-result-check-content-ref-exists"
                     test="if( xccdf:result ne 'notapplicable' and xccdf:result ne 'notchecked' and xccdf:result ne 'notselected') then (exists(current()//xccdf:check) and (every $m in current()//xccdf:check satisfies if(not(exists($m/xccdf:check-content-ref/@name))) then exists($m/xccdf:check-content-ref/@href) and count($m/ancestor::arf:asset-report-collection[1]/arf:report-requests//xccdf:Rule[@id eq $m/ancestor::node()/@idref]) eq 1 and not(exists($m/ancestor::arf:asset-report-collection[1]/arf:report-requests//xccdf:Rule[@id eq $m/ancestor::node()/@idref]/xccdf:check/xccdf:check-content-ref/@name)) and not(exists($m/ancestor::arf:asset-report-collection[1]/arf:report-requests//xccdf:Rule[@id eq $m/ancestor::node()/@idref]/xccdf:check[@multi-check eq 'true'])) else exists(.//xccdf:check/xccdf:check-content-ref[exists(@href) and exists(@name)]))) else true()">Every &lt;xccdf:rule-result&gt; other than 'notapplicable', 'notchecked', or 'notselected' must have a &lt;xccdf:check&gt;/&lt;xccdf:check-content-ref&gt; that has attributes @href and @name. One exception is when the referenced &lt;xccdf:Rule&gt; contains @multi-check=false(the default) and has no @name.|260-1</sch:assert>
         <sch:assert id="scap-result-general-xccdf-rule-result-check-ref-hash"
                     test="(every $m in .//xccdf:check-content-ref satisfies current()/ancestor::arf:asset-report-collection[1]//arf:report[concat('#',@id) eq $m/@href]) and (every $m in .//xccdf:check-content-ref satisfies parent::*/parent::*/parent::*[concat('#',@id) ne $m/@href])">The @href attribute SHALL contain "#" + the @id of the &lt;arf:report&gt; containing the check result. This approach provides traceability between XCCDF and check results.|370-1</sch:assert>
         <sch:assert id="scap-result-general-xccdf-rule-result-check-ref-valid"
                     test="every $m in .//xccdf:check-content-ref satisfies if (contains($m/parent::xccdf:check/@system,'oval')) then current()/ancestor::arf:asset-report-collection[1]//arf:report[@id eq translate($m/@href,'#','')]/arf:content/*[local-name() eq 'oval_results'] else if (contains($m/parent::xccdf:check/@system,'ocil')) then current()/ancestor::arf:asset-report-collection[1]//arf:report[@id eq translate($m/@href,'#','')]/arf:content/*[local-name() eq 'ocil'] else false()">Depending on the checking engine used (OVAL or OCIL), the the &lt;arf:report&gt; element should contain the relevant (OVAL or OCIL) content.|370-2</sch:assert>
      </sch:rule>
      <sch:rule id="scap-result-general-report" context="arf:report">
         <sch:assert id="scap-result-general-report-xccdf-use-test-result"
                     test="if( namespace-uri(arf:content/*[1]) eq 'http://checklists.nist.gov/xccdf/1.2' ) then exists(arf:content/xccdf:TestResult) else true()">XCCDF test results SHALL be documented as the contents of an &lt;xccdf:TestResult&gt; element. |131-1|arf:report <sch:value-of select="@id"/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-result-general-xccdf-test-result" context="xccdf:TestResult">
         <sch:assert id="scap-result-general-xccdf-test-result-start-end-time"
                     test="exists(@start-time) and exists(@end-time)">The @start-time and @end-time attributes SHALL be provided to indicate when the scan started and completed, respectively.|133-1</sch:assert>
         <sch:assert id="scap-result-general-xccdf-test-result-test-system"
                     test="exists(@test-system) and (matches(@test-system,'^[c][pP][eE]:/[AHOaho]?(:[A-Za-z0-9\._\-~%]*){0,6}$') or matches(@test-system,'^cpe:2\.3:[aho\*-](:(((\?*|\*?)([a-zA-Z0-9\-\._]|(\\[\\\*\?!&#34;#$$%&amp;\(\)\+,/:;&lt;=&gt;@\[\]\^`\{{\|}}~]))+(\?*|\*?))|[\*-])){5}(:(([a-zA-Z]{2,3}(-([a-zA-Z]{2}|[0-9]{3}))?)|[\*-]))(:(((\?*|\*?)([a-zA-Z0-9\-\._]|(\\[\\\*\?!&#34;#$$%&amp;\(\)\+,/:;&lt;=&gt;@\[\]\^`\{{\|}}~]))+(\?*|\*?))|[\*-])){4}$'))">The @test-system attribute SHALL be provided with a CPE Name value indicating the product that evaluated the checklist. |134-1</sch:assert>
         <sch:assert id="scap-result-general-xccdf-test-result-target-address"
                     test="count(xccdf:target) &gt; 0 and count(xccdf:target-address) &gt; 0">The &lt;xccdf:target&gt; and &lt;xccdf:target-address&gt; elements SHALL be provided.|136-1</sch:assert>
         <sch:assert id="scap-result-general-xccdf-test-result-target-address-content"
                     test="every $m in xccdf:target-address satisfies matches($m, '([0-9]|[1-9][0-9]|1([0-9][0-9])|2([0-4][0-9]|5[0-5]))\.([0-9]|[1-9][0-9]|1([0-9][0-9])|2([0-4][0-9]|5[0-5]))\.([0-9]|[1-9][0-9]|1([0-9][0-9])|2([0-4][0-9]|5[0-5]))\.([0-9]|[1-9][0-9]|1([0-9][0-9])|2([0-4][0-9]|5[0-5]))') or matches($m, '([0-9a-fA-F]{1,4}:){7}[0-9a-fA-F]{1,4}')">The &lt;xccdf:target-address&gt; SHALL contain an IP address|136-2</sch:assert>
         <sch:assert id="scap-result-general-xccdf-test-result-benchmark-id-req"
                     test="exists(xccdf:benchmark[exists(@id)])">If the &lt;xccdf:TestResult&gt; is the root XCCDF element, then it will include an &lt;xccdf:benchmark&gt; element [XCCDF:6.6.2]. The &lt;xccdf:benchmark&gt; element MUST have an @id attribute specified.|253-1</sch:assert>
         <sch:assert id="scap-result-general-xccdf-test-result-target-id-ref"
                     test="exists(.//xccdf:target-id-ref[@system eq 'http://scap.nist.gov/schema/asset-identification/1.1' and @href eq '' and @name eq current()/ancestor::arf:asset-report-collection[1]/rc:relationships/rc:relationship[@subject eq current()/ancestor::arf:report[1]/@id and (resolve-QName(@type,.) eq QName('http://scap.nist.gov/vocabulary/arf/relationships/1.0#','isAbout') or resolve-QName(@type,.) eq QName('http://scap.nist.gov/specifications/arf/vocabulary/relationships/1.0#','isAbout'))]/rc:ref[1]])">An &lt;xccdf:target-id-ref&gt; SHALL be specified with a @system attribute of "http://scap.nist.gov/schema/asset-identification/1.1", an @href attribute value of "", and a @name attribute value of the ID of the &lt;ai:asset&gt; element in the ARF that this &lt;xccdf:TestResult&gt; is about.|304-1</sch:assert>
         <sch:assert id="scap-result-general-xccdf-test-result-identity-provided"
                     test="exists(xccdf:identity) and (every $m in xccdf:identity satisfies matches($m,'\S'))">At least one &lt;xccdf:identity&gt; element SHALL be provided and SHALL contain text to identify the security principal.|42-1</sch:assert>
      </sch:rule>
      <sch:rule id="scap-result-general-oval-results" context="oval-res:oval_results">
         <sch:assert id="scap-result-oval-results-result-type"
                     test="(count(oval-res:directives/*) eq 6) and (every $m in oval-res:directives/* satisfies(($m/@reported eq 'true') and (if(exists($m/following-sibling::*)) then (if ($m/@content eq 'thin') then ($m/following-sibling::*[1]/@content eq 'thin' or not(exists($m/following-sibling::*[1]/@content))) else if ($m/@content eq 'full' or not(exists($m/@content))) then ($m/following-sibling::*[1]/@content eq 'full' or not(exists($m/following-sibling::*[1]/@content))) else false()) else true())))">The &lt;oval-res:directives&gt; element SHALL be:&lt;definition_true content="full" reported="true"/&gt;~&lt;definition_false content="full" reported="true"/&gt;~&lt;definition_unknown content="full" reported="true"/&gt;~&lt;definition_error content="full" reported="true"/&gt;~&lt;definition_not_evaluated content="full" reported="true"/&gt;~&lt;definition_not_applicable content="full" reported="true"/&gt; or &lt;definition_true reported="true"/&gt;~&lt;definition_false reported="true"/&gt;~&lt;definition_unknown reported="true"/&gt;~&lt;definition_error reported="true"/&gt;~&lt;definition_not_evaluated reported="true"/&gt;~&lt;definition_not_applicable reported="true"/&gt; or &lt;definition_true content="thin" reported="true"/&gt;~&lt;definition_false content="thin" reported="true"/&gt;~&lt;definition_unknown content="thin" reported="true"/&gt;~&lt;definition_error content="thin" reported="true"/&gt;~&lt;definition_not_evaluated content="thin" reported="true"/&gt;~&lt;definition_not_applicable content="thin" reported="true"/&gt;|179-1</sch:assert>
         <sch:assert id="scap-result-oval-results-sys-wo-char"
                     test="if( oval-res:directives/*[1]/@content eq 'full' or not(exists(oval-res:directives/*[1]/@content))) then ((exists(.//oval-sc:oval_system_characteristics/oval-sc:collected_objects) and exists(.//oval-sc:oval_system_characteristics/oval-sc:system_data)) or ((not(exists(.//oval-sc:oval_system_characteristics/oval-sc:collected_objects)) and not(exists(.//oval-sc:oval_system_characteristics/oval-sc:system_data))))) else true()">Error if oval-res directives definitions have @content='full' or @content is not provided and oval-res:oval_system_characteristics does not have both oval-res:collected_objects and oval-res:system_data.  In that case it is Single Machine Without System Characteristics.|181-1</sch:assert>
      </sch:rule>
      <sch:rule id="scap-result-general-ai-asset" context="arf:asset">
         <sch:assert id="scap-result-general-ai-asset-certain-fields-req"
                     test="(exists(.//ai:ip-v4) or exists(.//ai:ip-v6)) and exists(.//ai:mac-address) and (.//ai:fqdn) and (.//ai:hostname)">The target asset MUST be represented in the ARF report using the &lt;ai:assets&gt; part of ARF. The &lt;ai:asset&gt; element populated about a target asset SHOULD include the fields specified in Table 18, where applicable|299-1|arf:asset <sch:value-of select="@id"/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-result-general-report-collection"
                context="arf:asset-report-collection">
         <sch:assert id="scap-result-general-report-collection-include-report-request"
                     test="exists(.//arf:report-request)">The source data stream collection that was used to generate the results against the target SHOULD be included in the ARF report as an &lt;arf:report-request&gt;.|300-1|arf:asset-report-collection <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-result-general-arf-rel-namespace"
                     test="every $m in current()/rc:relationships/rc:relationship satisfies($m[resolve-QName(@type,.) != QName('http://scap.nist.gov/vocabulary/arf/relationships/1.0#','isAbout')])">NIST SP800-126 errata has updated the "arf-rel" namespace to http://scap.nist.gov/specifications/arf/vocabulary/relationships/1.0#  The original namespace of http://scap.nist.gov/vocabulary/arf/relationships/1.0# has been detected.|304-2</sch:assert>
	        <sch:assert id="scap-result-general-report-collection-report-request-not-included"
                     test="exists(.//arf:report-request)">The source data stream collection SHOULD be included in the ARF report as an &lt;arf:report-request&gt;. The user should run SCAPVal using the -source_ds argument to specify the source data stream collection that was used to generate the results.|A24|arf:asset-report-collection <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-result-general-signature-sig-counter-sign-remove-orig"
                     test="every $m in .//arf:extended-info/dsig:Signature satisfies count($m/ancestor::arf:asset-report-collection[1]//dsig:Signature[@Id eq $m/@Id]) eq 1">In situations where it is desirable to countersign a result data stream (e.g., when a content consumer automatically signs a result data stream and then a person also wants to sign the results), the following requirements apply.~The &lt;arf:extended-info&gt; element containing the original signature SHALL be removed from the resulting document.|316-1|arf:asset-report-collection <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-result-general-report-collection-sig-report-request"
                     test="if( exists(.//arf:extended-info/dsig:Signature) ) then exists(.//arf:report-request) else true() ">When signing a result data stream, the source data stream collection SHOULD be captured in the ARF report being signed.|323-1|arf:asset-report-collection <sch:value-of select="@id"/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-result-general-oval-sys"
                context="oval-sc:oval_system_characteristics">
         <sch:assert id="scap-result-general-oval-sys-system-info"
                     test="if (exists(current()/oval-sc:system_info/scap-con:asset-identification/arf:object-ref)) then( some $m in current()/ancestor::arf:asset-report-collection[1]/rc:relationships/rc:relationship[@subject eq current()/ancestor::arf:report[1]/@id] satisfies (exists( $m[resolve-QName(@type,.) eq QName('http://scap.nist.gov/vocabulary/arf/relationships/1.0#','isAbout') or resolve-QName(@type,.) eq QName('http://scap.nist.gov/specifications/arf/vocabulary/relationships/1.0#','isAbout')]) and current()/oval-sc:system_info/scap-con:asset-identification/arf:object-ref/@ref-id eq $m/rc:ref[1])) else false()">When specifying OVAL system characteristics, a reference SHOULD be made to the target asset in the ARF report collection. Specifically, the &lt;oval-sc:oval_system_characteristics&gt;/&lt;oval-sc:system_info&gt;/##any SHOULD be populated with a &lt;con:asset-identification&gt; element. That element MUST be populated with a single &lt;arf:object-ref&gt; element that points to the &lt;ai:asset&gt; element in the ARF report collection pertaining to the OVAL result. See [ARF] for details on populating the &lt;arf:object-ref&gt; element.|306-1</sch:assert>
      </sch:rule>
      <sch:rule id="scap-result-general-signature-sig"
                context="arf:extended-info/dsig:Signature">
         <sch:assert id="scap-result-general-signature-sig-sig-properties"
                     test="exists(.//tmsad:signature-info)">A &lt;dsig:SignatureProperties&gt; element MUST be included in the &lt;dsig:Signature&gt; element. At least one &lt;dsig:SignatureProperty&gt; element MUST be populated with &lt;dt:signature-info&gt; as specified in [TMSAD].|311-1|dsig:Signature <sch:value-of select="@Id"/>
         </sch:assert>
         <sch:assert id="scap-result-general-signature-sig-first-ref"
                     test="some $m in .//dsig:Reference[1] satisfies ($m/@URI eq '' or exists(current()//dsig:Object[concat('#',@Id) eq $m/@URI]))">The first &lt;dsig:Reference&gt; element in a &lt;dsig:Signature&gt; element MUST be to the &lt;arf:asset-report-collection&gt; element. The element MUST be referenced in the @URI attribute using the empty string convention "".|312-1|dsig:Signature <sch:value-of select="@Id"/>
         </sch:assert>
         <sch:assert id="scap-result-general-signature-sig-xpath-filter"
                     test="count(.//dsig:Reference[1]//dsig:Transform[@Algorithm eq 'http://www.w3.org/2002/06/xmldsig-filter2']) eq 2">Two XPath Filter 2 transforms MUST exist on the first &lt;dsig:Reference&gt; element in a &lt;dsig:Signature&gt; element. Both MUST specify a filter type of "subtract". The first transform MUST specify the XPath "/arf:asset-report-collection/arf:extended-infos[count(arf:extended-info[dsig:Signature]) = count(*)]". The second transform MUST specify the XPath "/arf:asset-report-collection/arf:extended-infos/arf:extended-info[dsig:Signature]". In both cases, the namespace prefix "arf" MUST map to the ARF namespace specified in this document.|313-1|dsig:Signature <sch:value-of select="@Id"/>
         </sch:assert>
         <sch:assert id="scap-result-general-signature-sig-sig-property"
                     test="exists(.//dsig:SignatureProperties[concat('#',@Id) eq current()/dsig:SignedInfo/dsig:Reference[2]/@URI])">The second &lt;dsig:Reference&gt; element MUST be to the &lt;dsig:SignatureProperties&gt; element captured in a &lt;dsig:Object&gt; element with the &lt;dsig:Signature&gt; element. The &lt;dsig:SignatureProperties&gt; element MUST be referenced in the @URI attribute using "#" + @Id of the &lt;dsig:SignatureProperties&gt;|314-1|dsig:Signature <sch:value-of select="@Id"/>
         </sch:assert>
         <sch:assert id="scap-result-general-signature-sig-key-info"
                     test="exists(dsig:KeyInfo)">Key information SHOULD be provided on the &lt;dsig:Signature&gt; element.|315-1|dsig:Signature <sch:value-of select="@Id"/>
         </sch:assert>
      </sch:rule>
  </sch:pattern>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-all-profile-parents">
      <xsl:param name="doc"/>
      <xsl:param name="node"/>
      <xsl:sequence select="$node"/>
      <xsl:if test="exists($node/@extends)">
         <xsl:sequence select="xcf:get-all-profile-parents($doc,$doc//xccdf:Benchmark//xccdf:Profile[@id eq $node/@extends])"/>
      </xsl:if>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-component">
      <xsl:param name="component-ref"/>
      <xsl:sequence select="$component-ref/ancestor::ds:data-stream-collection//ds:component[@id eq substring($component-ref/@xlink:href,2)]"/>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 xmlns="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-all-def-children">
      <xsl:param name="doc"/>
      <xsl:param name="node"/>
      <xsl:sequence select="$node"/>
      <xsl:for-each select="$doc//oval-def:extend_definition[@definition_ref eq $node/@id]/ancestor::oval-def:definition">
         <xsl:sequence select="xcf:get-all-def-children($doc,current())"/>
      </xsl:for-each>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:ident-mapping">
      <xsl:param name="in-string"/>
      <xsl:choose>
         <xsl:when test="$in-string eq 'http://cce.mitre.org'">
            <xsl:value-of select="string('^(CCE|http://cce.mitre.org)$')"/>
         </xsl:when>
         <xsl:when test="$in-string eq 'http://cve.mitre.org'">
            <xsl:value-of select="string('^(CVE|http://cve.mitre.org)$')"/>
         </xsl:when>
         <xsl:when test="$in-string eq 'http://cpe.mitre.org'">
            <xsl:value-of select="string('^(CPE|http://cpe.mitre.org)$')"/>
         </xsl:when>
      </xsl:choose>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-all-parents">
      <xsl:param name="doc"/>
      <xsl:param name="node"/>
      <xsl:sequence select="$node"/>
      <xsl:for-each select="$node//oval-def:extend_definition">
         <xsl:sequence select="xcf:get-all-parents($doc,ancestor::oval-def:oval_definitions//*[@id eq current()/@definition_ref])"/>
      </xsl:for-each>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-ocil-var-ref">
      <xsl:param name="ocil_questionnaire"/>
      <xsl:variable name="initialSet">
         <xsl:for-each select="$ocil_questionnaire/ocil:actions/ocil:test_action_ref">
            <xsl:sequence select="ancestor::ocil:ocil/ocil:test_actions/ocil:numeric_question_test_action[@id eq current()]/ocil:when_equals[@var_ref]"/>
            <xsl:sequence select="ancestor::ocil:ocil/ocil:test_actions/ocil:string_question_test_action[@id eq current()]/ocil:when_pattern/ocil:pattern[@var_ref]"/>
            <xsl:sequence select="ancestor::ocil:ocil/ocil:test_actions/ocil:numeric_question_test_action[@id eq current()]/ocil:when_range/ocil:range/ocil:min[@var_ref]"/>
            <xsl:sequence select="ancestor::ocil:ocil/ocil:test_actions/ocil:numeric_question_test_action[@id eq current()]/ocil:when_range/ocil:range/ocil:max[@var_ref]"/>
            <xsl:for-each select="ancestor::ocil:ocil/ocil:test_actions/*[@id eq current()]">
               <xsl:sequence select="ancestor::ocil:ocil/ocil:questions/ocil:choice_question[@id eq current()/@question_ref]/ocil:choice[@var_ref]"/>
               <xsl:for-each select="ancestor::ocil:ocil/ocil:questions/ocil:choice_question[@id eq current()/@question_ref]/ocil:choice_group_ref">
                  <xsl:sequence select="ancestor::ocil:questions/ocil:choice_group[@id eq current()]/ocil:choice[@var_ref]"/>
               </xsl:for-each>
            </xsl:for-each>
         </xsl:for-each>
      </xsl:variable>
      <xsl:for-each select="$initialSet/*">
         <xsl:sequence select="xcf:pass-ocil-var-ref($ocil_questionnaire,current())"/>
      </xsl:for-each>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-component-ref">
      <xsl:param name="catalog"/>
      <xsl:param name="uri"/>
      <xsl:variable name="component-ref-uri"
                    select="xcf:resolve-in-catalog($catalog/*[1],$uri)"/>
      <xsl:if test="$component-ref-uri ne ''">
         <xsl:sequence select="$catalog/ancestor::ds:data-stream//ds:component-ref[@id eq substring($component-ref-uri,2)]"/>
      </xsl:if>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:pass-ocil-var-ref">
      <xsl:param name="ocil_questionnaire"/>
      <xsl:param name="var_ref"/>
      <xsl:sequence select="$var_ref"/>
      <xsl:for-each select="$ocil_questionnaire/ancestor::ocil:ocil/ocil:variables/ocil:local_variable[@id eq $var_ref/@var_ref]/ocil:set/ocil:when_range/ocil:min[@var_ref]">
         <xsl:sequence select="xcf:pass-ocil-var-ref($ocil_questionnaire,current())"/>
      </xsl:for-each>
      <xsl:for-each select="$ocil_questionnaire/ancestor::ocil:ocil/ocil:variables/ocil:local_variable[@id eq $var_ref/@var_ref]/ocil:set/ocil:when_range/ocil:max[@var_ref]">
         <xsl:sequence select="xcf:pass-ocil-var-ref($ocil_questionnaire,current())"/>
      </xsl:for-each>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:resolve-in-catalog">
      <xsl:param name="resolver-node"/>
      <xsl:param name="uri"/>
      <xsl:choose>
         <xsl:when test="starts-with($uri,'#')">
            <xsl:value-of select="$uri"/>
         </xsl:when>
         <xsl:when test="exists($resolver-node)">
            <xsl:choose>
               <xsl:when test="$resolver-node/local-name() eq 'uri'">
                  <xsl:choose>
                     <xsl:when test="$resolver-node/@name eq $uri">
                        <xsl:value-of select="$resolver-node/@uri"/>
                     </xsl:when>
                     <xsl:otherwise>
                        <xsl:value-of select="xcf:resolve-in-catalog($resolver-node/following-sibling::*[1], $uri)"/>
                     </xsl:otherwise>
                  </xsl:choose>
               </xsl:when>
               <xsl:when test="$resolver-node/local-name() eq 'rewriteURI'">
                  <xsl:choose>
                     <xsl:when test="starts-with($uri,$resolver-node/@uriStartString)">
                        <xsl:value-of select="concat($resolver-node/@rewritePrefix,substring($uri,string-length($resolver-node/@uriStartString)+1))"/>
                     </xsl:when>
                     <xsl:otherwise>
                        <xsl:value-of select="xcf:resolve-in-catalog($resolver-node/following-sibling::*[1], $uri)"/>
                     </xsl:otherwise>
                  </xsl:choose>
               </xsl:when>
            </xsl:choose>
         </xsl:when>
      </xsl:choose>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 xmlns="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-all-external-vars">
      <xsl:param name="doc"/>
      <xsl:param name="node"/>
      <xsl:sequence select="$doc//oval-def:external_variable[@id eq $node/@var_ref]"/>
      <xsl:for-each select="$doc//*[@id eq $node/@var_ref]//*[@var_ref]">
         <xsl:sequence select="xcf:get-all-external-vars($doc,current())"/>
      </xsl:for-each>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:is-external-ref">
      <xsl:param name="catalog"/>
      <xsl:param name="uri"/>
      <xsl:variable name="comp-ref" select="xcf:get-component-ref($catalog,$uri)"/>
      <xsl:choose>
         <xsl:when test="exists($comp-ref)">
            <xsl:value-of select="not(starts-with($comp-ref/@xlink:href,'#'))"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="false()"/>
         </xsl:otherwise>
      </xsl:choose>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-all-group-parents">
      <xsl:param name="doc"/>
      <xsl:param name="node"/>
      <xsl:sequence select="$node"/>
      <xsl:if test="exists($node/@extends)">
         <xsl:sequence select="xcf:get-all-group-parents($doc,$doc//xccdf:Benchmark//xccdf:Group[@id eq $node/@extends])"/>
      </xsl:if>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-locator-prefix">
      <xsl:param name="name"/>
      <xsl:variable name="subName"
                    select="substring($name,1,string-length($name) - string-length(tokenize($name,'-')[last()]) - 1)"/>
      <xsl:choose>
         <xsl:when test="ends-with($subName,'cpe')">
            <xsl:value-of select="xcf:get-locator-prefix($subName)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="tokenize($subName,'/')[last()]"/>
         </xsl:otherwise>
      </xsl:choose>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-locator-prefix-res">
      <xsl:param name="name"/>
      <xsl:variable name="subName"
                    select="substring($name,1,string-length($name) - string-length(tokenize($name,'-')[last()]) - 1)"/>
      <xsl:value-of select="xcf:get-locator-prefix($subName)"/>
  </xsl:function>
</sch:schema>
