<?xml version="1.0" encoding="UTF-8"?>
<!--These rules are for informational purposes only and DO NOT supersede the requirements in NIST SP 800-126 Rev 2.-->
<!--These rules may be revised at anytime. Comments/feedback on these rules are welcome.-->
<!--Private comments may be sent to scap@nist.gov.  Public comments may be sent to scap-dev@nist.gov.-->
<sch:schema xmlns:sch="http://purl.oclc.org/dsdl/schematron" queryBinding="xslt2">
  <sch:ns prefix="ai" uri="http://scap.nist.gov/schema/asset-identification/1.1"/>
  <sch:ns prefix="arf"
           uri="http://scap.nist.gov/schema/asset-reporting-format/1.1"/>
  <sch:ns prefix="cat" uri="urn:oasis:names:tc:entity:xmlns:xml:catalog"/>
  <sch:ns prefix="cpe-dict" uri="http://cpe.mitre.org/dictionary/2.0"/>
  <sch:ns prefix="cpe-lang" uri="http://cpe.mitre.org/language/2.0"/>
  <sch:ns prefix="dc" uri="http://purl.org/dc/elements/1.1/"/>
  <sch:ns prefix="ds" uri="http://scap.nist.gov/schema/scap/source/1.2"/>
  <sch:ns prefix="dsig" uri="http://www.w3.org/2000/09/xmldsig#"/>
  <sch:ns prefix="java" uri="java:gov.nist.scap.schematron"/>
  <sch:ns prefix="nvd-config"
           uri="http://scap.nist.gov/schema/feed/configuration/0.1"/>
  <sch:ns prefix="ocil" uri="http://scap.nist.gov/schema/ocil/2.0"/>
  <sch:ns prefix="oval-com" uri="http://oval.mitre.org/XMLSchema/oval-common-5"/>
  <sch:ns prefix="oval-def"
           uri="http://oval.mitre.org/XMLSchema/oval-definitions-5"/>
  <sch:ns prefix="oval-res" uri="http://oval.mitre.org/XMLSchema/oval-results-5"/>
  <sch:ns prefix="oval-sc"
           uri="http://oval.mitre.org/XMLSchema/oval-system-characteristics-5"/>
  <sch:ns prefix="rc" uri="http://scap.nist.gov/schema/reporting-core/1.1"/>
  <sch:ns prefix="scap" uri="http://scap.nist.gov/schema/scap/source/1.2"/>
  <sch:ns prefix="scap-con" uri="http://scap.nist.gov/schema/scap/constructs/1.2"/>
  <sch:ns prefix="tmsad" uri="http://scap.nist.gov/schema/xml-dsig/1.0"/>
  <sch:ns prefix="xccdf" uri="http://checklists.nist.gov/xccdf/1.2"/>
  <sch:ns prefix="xcf" uri="nist:scap:xslt:function"/>
  <sch:ns prefix="xinclude" uri="http://www.w3.org/2001/XInclude"/>
  <sch:ns prefix="xlink" uri="http://www.w3.org/1999/xlink"/>
  <sch:ns prefix="xml" uri="http://www.w3.org/XML/1998/namespace"/>
  <sch:ns prefix="xsd" uri="http://www.w3.org/2001/XMLSchema"/>
  <sch:pattern id="scap-general">
      <sch:rule id="scap-general-xccdf-benchmark" context="xccdf:Benchmark">
         <sch:assert id="scap-general-xccdf-description"
                     test="every $m in (. union .//xccdf:Profile union .//xccdf:Value union .//xccdf:Group union .//xccdf:Rule) satisfies exists($m/xccdf:description)">For each &lt;xccdf:Benchmark&gt;, &lt;xccdf:Profile&gt;, &lt;xccdf:Value&gt;, &lt;xccdf:Group&gt;, and &lt;xccdf:Rule&gt; element, a &lt;xccdf:description&gt; SHALL be provided.|10-1|xccdf:Benchmark <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-benchmark-lang-required"
                     test="exists(@xml:lang)">@xml:lang attribute SHALL be provided on &lt;xccdf:Benchmark&gt; elements.|2-1|xccdf:Benchmark <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-no-check-content-check"
                     test="not(exists(.//xccdf:check-content))">A XCCDF document SHALL NOT contain an &lt;xccdf:check-content&gt; element|25-1|xccdf:Benchmark <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-benchmark-val-forbid"
                     test="not(exists(.//xccdf:Value//xccdf:source)) and not(exists(.//xccdf:Value//xccdf:complex-value)) and not(exists(.//xccdf:Value//xccdf:complex-default)) and not(exists(.//xccdf:Value//xccdf:choices//xccdf:complex-choice))">The use of the &lt;xccdf:source&gt;, &lt;xccdf:complex-value&gt;, and &lt;xccdf:complex-default&gt; elements within the &lt;xccdf:Value&gt; element SHALL NOT be allowed.  Within the &lt;xccdf:choices&gt; element of the &lt;xccdf:Value&gt; element, the use of the &lt;xccdf:complex-choice&gt; element SHALL NOT be allowed|276-1|xccdf:Benchmark <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-benchmark-no-xinclude"
                     test="not(exists(.//xinclude:include))">XInclude elements SHALL NOT be included in XCCDF content [XINCLUDE].|339-1|xccdf:Benchmark <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-benchmark-no-set-complex-value"
                     test="not(exists(.//xccdf:set-complex-value))">Use of the &lt;xccdf:set-complex-value&gt; element within the &lt;xccdf:Profile&gt; element SHALL NOT be allowed.|343-1|xccdf:Benchmark <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-benchmark-no-group-extension"
                     test="every $m in .//xccdf:Group satisfies not(exists($m/@extends))">XCCDF group extension SHALL NOT be allowed.|354-1|xccdf:Benchmark <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-style" test="@style eq 'SCAP_1.2'">The style attribute of the &lt;xccdf:Benchmark&gt; element SHOULD contain the value "SCAP_1.2".|4-1|xccdf:Benchmark <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-metadata-missing" test="exists(xccdf:metadata)">The &lt;xccdf:metadata&gt; element SHALL be provided in the &lt;xccdf:Benchmark&gt; element.|8-2|xccdf:Benchmark <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-metadata-populated"
                     test="if( exists(xccdf:metadata) ) then exists(xccdf:metadata/dc:creator) and exists(xccdf:metadata/dc:publisher) and exists(xccdf:metadata/dc:contributor) and exists(xccdf:metadata/dc:source) else true()">xccdf:Benchmark/xccdf:metadata SHALL contain, at minimum, one of each of the Dublin Core terms &lt;dc:creator&gt;, &lt;dc:publisher&gt;, &lt;dc:contributor&gt;, &lt;dc:source&gt;|8-1|xccdf:Benchmark <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-title-1"
                     test="every $m in (. union .//xccdf:Profile union .//xccdf:Value union .//xccdf:Group union .//xccdf:Rule) satisfies exists($m/xccdf:title)">For all &lt;xccdf:Benchmark&gt;, &lt;xccdf:Profile&gt;, &lt;xccdf:Value&gt;, &lt;xccdf:Group&gt;, and &lt;xccdf:Rule&gt;, check for the existence of &lt;xccdf:title&gt;; if not found, the content shall be considered to be in error.|9-1|xccdf:Benchmark <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-title-3"
                     test="every $m in (. union .//xccdf:Profile union .//xccdf:Value union .//xccdf:Group union .//xccdf:Rule) satisfies if( count($m/xccdf:title) gt 1 ) then exists($m/xccdf:title[@xml:lang eq 'en-US']) else true()">For all &lt;xccdf:Benchmark&gt;, &lt;xccdf:Profile&gt;, &lt;xccdf:Value&gt;, &lt;xccdf:Group&gt;, and &lt;xccdf:Rule&gt;, check for the existence of &lt;xccdf:title&gt;; if not found, the content shall be considered to be in error.|9-3|xccdf:Benchmark <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-title-2"
                     test="every $m in (. union .//xccdf:Profile union .//xccdf:Value union .//xccdf:Group union .//xccdf:Rule) satisfies (if( count($m/xccdf:title) gt 1 ) then count($m/xccdf:title) eq count($m/xccdf:title[@xml:lang]) else true())">For all &lt;xccdf:Benchmark&gt;, &lt;xccdf:Profile&gt;, &lt;xccdf:Value&gt;, &lt;xccdf:Group&gt;, and &lt;xccdf:Rule&gt;, check for the existence of &lt;xccdf:title&gt;; if not found, the content shall be considered to be in error.|9-2|xccdf:Benchmark <sch:value-of select="@id"/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-general-xccdf-check" context="xccdf:Rule/xccdf:check">
         <sch:assert id="scap-general-xccdf-check-sys-req"
                     test="@system eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5' or @system eq 'http://scap.nist.gov/schema/ocil/2'">@system on &lt;xccdf:check&gt; MUST be "http://oval.mitre.org/XMLSchema/oval-definitions-5" or "http://scap.nist.gov/schema/ocil/2"|118-1|xccdf:Rule <sch:value-of select="ancestor::xccdf:Rule[1]/@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-check-multi-check"
                     test="if( ancestor::xccdf:Rule[1][ends-with(@id,'security_patches_up_to_date')] ) then matches(@multi-check,'^(true|1)$') else true()">If a rule is doing a "patches up-to-date" check, then the @multi-check attribute on each xccdf:check in that rule SHOULD be set to "true". This requirement was removed in SCAP Schematron version 1.1.|275-1|xccdf:Rule <sch:value-of select="ancestor::xccdf:Rule[1]/@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-check-supported-check-systems"
                     test="@system eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5' or @system eq 'http://scap.nist.gov/schema/ocil/2'">Only OVAL and OCIL are supported check systems|351-1|xccdf:Rule <sch:value-of select="ancestor::xccdf:Rule[1]/@id"/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-general-scap-content" context="scap:data-stream">
         <sch:assert id="scap-general-scap-content-every-cpe-equal-subset"
                     test="if( function-available('java:isEqualOrSuperset') ) then (every $m in ds:checklists/ds:component-ref satisfies ((every $n in xcf:get-component($m)//xccdf:platform[not(starts-with(@idref,'#'))] satisfies some $o in ds:dictionaries/ds:component-ref satisfies some $p in xcf:get-component($o)//cpe-dict:cpe-item satisfies java:isEqualOrSuperset($n/@idref,$p/@name)) and (every $q in xcf:get-component($m)//cpe-lang:fact-ref satisfies some $r in ds:dictionaries/ds:component-ref satisfies some $s in xcf:get-component($r)//cpe-dict:cpe-item satisfies java:isEqualOrSuperset($q/@name,$s/@name)))) else true()">Every &lt;xccdf:platform&gt; or &lt;cpe2:fact-ref&gt; MUST match as EQUAL or SUPERSET to a CPE in a CPE dictionary component of this data stream.|15-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-check-content-ref-patch-id-req"
                     test="every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:Rule[starts-with(@id,'xccdf_') and ends-with(@id,'_rule_security_patches_up_to_date')]//xccdf:check-content-ref[not(xcf:is-external-ref($m/cat:catalog, @href) cast as xsd:boolean)] satisfies exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $n/@href))//oval-def:definition[@class eq 'patch'])">An xccdf:Rule with @id "xccdf_NAMESPACE_rule_security_patches_up_to_date" MUST reference an OVAL component that contains an oval definition of class 'patch'. If your content contains external references, SCAPVal will attempt to resolve it in -online mode.|169-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-use-case-conf-verification-rule-ref-oval"
                     test="if( @use-case eq 'CONFIGURATION' ) then every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:Rule satisfies (if(exists($n/xccdf:check[@system eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5' or @system eq 'http://scap.nist.gov/schema/ocil/2']/xccdf:check-content-ref[exists(@name) and not(xcf:is-external-ref($m/cat:catalog, @href) cast as xsd:boolean)])) then some $o in $n/xccdf:check[@system eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5' or @system eq 'http://scap.nist.gov/schema/ocil/2']/xccdf:check-content-ref[exists(@name) and not(xcf:is-external-ref($m/cat:catalog, @href) cast as xsd:boolean)] satisfies (exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $o/@href))//oval-def:definition[@id eq $o/@name and matches(@class,'^(compliance|patch)$')]) or exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $o/@href))//ocil:questionnaire[@id eq $o/@name])) else true()) else true()">Each xccdf:Rule must reference at least one of the follow items: OVAL compliance class, OCIL Questionnaire, OVAL patch class|236-2|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-use-case-conf-verification-content-xccdf-req"
                     test="if( @use-case eq 'CONFIGURATION' ) then exists(ds:checklists/ds:component-ref) else true()">For this CONFIGURATION @use-case, unable to find at least one &lt;xccdf:Benchmark&gt; element referenced in the &lt;ds:checklists&gt; child elements. Check your &lt;ds:component-ref&gt; @xlink:href values for validity. If your content contains external references, SCAPVal will attempt to resolve it in -online mode.|236-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-use-case-vul-assess-xccdf-oval-content-xccdf-req"
                     test="if( @use-case eq 'VULNERABILITY' ) then exists(ds:checklists/ds:component-ref) else true()">For this VULNERABILITY @use-case, unable to find at least one &lt;xccdf:Benchmark&gt; element referenced in the &lt;ds:checklists&gt; child elements. Check your &lt;ds:component-ref&gt; @xlink:href values for validity. If your content contains external references, SCAPVal will attempt to resolve it in -online mode.|242-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-use-case-vul-assess-xccdf-oval-rule-xccdf-oval-ref-req"
                     test="if( @use-case eq 'VULNERABILITY' ) then every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:Rule satisfies some $o in $n/xccdf:check[@system eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5' or @system eq 'http://scap.nist.gov/schema/ocil/2']/xccdf:check-content-ref[exists(@name) and not(xcf:is-external-ref($m/cat:catalog, @href) cast as xsd:boolean)] satisfies (exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $o/@href))//oval-def:definition[@id eq $o/@name and matches(@class,'^(vulnerability|patch)$')]) or exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $o/@href))//ocil:questionnaire[@id eq $o/@name])) else true()">Each xccdf:Rule must reference at least one of the follow components: OVAL vulnerability class, OCIL Questionnaire, OVAL patch class|242-2|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-use-case-inventory-collection-content-xccdf-req"
                     test="if( @use-case eq 'INVENTORY' ) then exists(ds:checklists/ds:component-ref) else true()">For this INVENTORY @use-case, unable to find at least one &lt;xccdf:Benchmark&gt; element referenced in the &lt;ds:checklists&gt; child elements. Check your &lt;ds:component-ref&gt; @xlink:href values for validity. If your content contains external references, SCAPVal will attempt to resolve it in -online mode.|248-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-use-case-inventory-collection-xccdf-rule-ref-oval-def-req"
                     test="if( @use-case eq 'INVENTORY' ) then every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:Rule satisfies some $o in $n/xccdf:check[@system eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5' or @system eq 'http://scap.nist.gov/schema/ocil/2']/xccdf:check-content-ref[exists(@name) and not(xcf:is-external-ref($m/cat:catalog, @href) cast as xsd:boolean)] satisfies (exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $o/@href))//oval-def:definition[@id eq $o/@name and matches(@class,'^(inventory)$')]) or exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $o/@href))//ocil:questionnaire[@id eq $o/@name])) else true()">Each xccdf:Rule must reference at least one OVAL definition in CPE_INVENTORY|248-2|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-rule-xccdf-oval-ref-match"
                     test="every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:ident[matches(@system,'^(http://cce.mitre.org|http://cve.mitre.org|http://cpe.mitre.org)$')] satisfies every $o in $n/ancestor::xccdf:Rule[1]/xccdf:check[@system eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5']/xccdf:check-content-ref[exists(@name)] satisfies exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $o/@href))//oval-def:definition[@id eq $o/@name]//oval-def:reference[matches(@source,xcf:ident-mapping($n/@system)) and $n eq @ref_id])">If an XCCDF rule references an OVAL definition, then &lt;xccdf:ident&gt; element content SHALL match the corresponding CVE, CCE, or CPE identifier found in the associated OVAL Definition(s).|251-2|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-use-case-conf-verification-benchmark-one-rule-ref-oval-ocil"
                     test="if( @use-case eq 'CONFIGURATION' ) then every $m in ds:checklists/ds:component-ref satisfies some $n in xcf:get-component($m)//xccdf:check[matches(@system,'^(http://oval\.mitre\.org/XMLSchema/oval-definitions-5|http://scap\.nist\.gov/schema/ocil/2)$')]/xccdf:check-content-ref[not(xcf:is-external-ref($m/cat:catalog,@href) cast as xsd:boolean)] satisfies (exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $n/@href))//ocil:questionnaire[@id eq $n/@name]) or exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $n/@href))//oval-def:definition[@id eq $n/@name and @class eq 'compliance'])) else true()">Each XCCDF Benchmark SHALL have at least one rule that references either an OVAL compliance class definition in an OVAL component or an OCIL questionnaire in an OCIL Questionnaire component. If your content contains external references, SCAPVal will attempt to resolve it in -online mode.|262-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-use-case-vul-assess-xccdf-benchmark-one-rule-ref-oval-ocil"
                     test="if( @use-case eq 'VULNERABILITY' ) then every $m in ds:checklists/ds:component-ref satisfies some $n in xcf:get-component($m)//xccdf:check[matches(@system,'^(http://oval\.mitre\.org/XMLSchema/oval-definitions-5|http://scap\.nist\.gov/schema/ocil/2)$')]/xccdf:check-content-ref[not(xcf:is-external-ref($m/cat:catalog,@href) cast as xsd:boolean)] satisfies (exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $n/@href))//ocil:questionnaire[@id eq $n/@name]) or exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $n/@href))//oval-def:definition[@id eq $n/@name and @class eq 'vulnerability'])) else true()">Each XCCDF Benchmark SHALL have at least one rule that references either an OVAL vulnerability definition in the an OVAL component or an OCIL questionnaire in the OCIL Questionnaire component.|265-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-scap-content-dict-and-oval-req"
                     test="if( @use-case eq 'CONFIGURATION' ) then every $m in ds:checklists/ds:component-ref satisfies (if( exists(xcf:get-component($m)//xccdf:platform) or exists(xcf:get-component($m)//cpe-dict:cpe-item) ) then (exists(ds:dictionaries/ds:component-ref) and (some $n in ds:checks/ds:component-ref satisfies exists(xcf:get-component($n)//oval-def:definition[@class eq 'inventory'])) ) else true()) else true()">If an XCCDF referenced from a data stream contains an &lt;xccdf:platform&gt; or &lt;cpe-lang:fact-ref&gt;, then a CPE dictionary component must be reference from the same data stream, and an OVAL component with a definition of class "inventory" must also be referenced.|30-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-scap-content-resolve-to-comp-ref"
                     test="every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:Rule//xccdf:check-content-ref satisfies exists(xcf:get-component-ref($m/cat:catalog, $n/@href))">When evaluating an &lt;xccdf:check-content-ref&gt; element within an &lt;xccdf:check&gt; element, its @href attribute either MUST contain a "#" + @id of a &lt;ds:component-ref&gt; element or MUST be resolved in the context of the XML Catalog specified as part of the &lt;ds:component-ref&gt; element that is referencing this benchmark. In either case, the @href attribute MUST ultimately resolve to a &lt;ds:component-ref&gt; element in the data stream referencing the benchmark containing this &lt;xccdf:check-content-ref&gt; element. See Section 3.1.1 for additional information on &lt;ds:component-ref&gt; resolution. If your content contains external references, SCAPVal will attempt to resolve it in -online mode.
  |31-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-scap-content-use-case"
                     test="matches(@use-case,'^(CONFIGURATION|VULNERABILITY|INVENTORY|OVAL_ONLY)$')">The @use-case attribute in the &lt;ds:data-stream&gt; element MUST be set to "CONFIGURATION", "VULNERABILITY", "INVENTORY" or "OTHER"|324-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-scap-content-vuln-cpe-inv-req"
                     test="if( @use-case eq 'VULNERABILITY' ) then every $m in ds:checklists/ds:component-ref satisfies (if( exists(xcf:get-component($m)//xccdf:platform) or exists(xcf:get-component($m)//cpe-dict:cpe-item) ) then (exists(ds:dictionaries/ds:component-ref) and (some $n in ds:checks/ds:component-ref satisfies exists(xcf:get-component($n)//oval-def:definition[@class eq 'inventory'])) ) else true()) else true()">If an XCCDF referenced from a data stream contains an &lt;xccdf:platform&gt; or &lt;cpe-lang:fact-ref&gt;, then a CPE dictionary component must be reference from the same data stream, and an OVAL component with a definition of class "inventory" must also be referenced.|33-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-scap-content-indent-match-to-oval-def-inv"
                     test="every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:Rule[exists(xccdf:ident[@system eq 'http://cpe.mitre.org'])]/xccdf:check[@system eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5']//xccdf:check-content-ref[not(xcf:is-external-ref($m/cat:catalog, @href) cast as xsd:boolean) and exists(@name)] satisfies exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $n/@href))//oval-def:definition[@id eq $n/@name and @class eq 'inventory'])">If an &lt;xccdf:Rule&gt; has an &lt;xccdf:ident&gt; with a CPE and that rule reference an OVAL definition, the definition SHALL have @class 'inventory'.|331-3|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-scap-content-indent-match-to-oval-def-comp"
                     test="every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:Rule[exists(xccdf:ident[@system eq 'http://cce.mitre.org'])]/xccdf:check[@system eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5']//xccdf:check-content-ref[not(xcf:is-external-ref($m/cat:catalog, @href) cast as xsd:boolean) and exists(@name)] satisfies exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $n/@href))//oval-def:definition[@id eq $n/@name and @class eq 'compliance'])">If an &lt;xccdf:Rule&gt; has an &lt;xccdf:ident&gt; with a CCE and that rule reference an OVAL definition, the definition SHALL have @class 'compliance'.|331-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-scap-content-indent-match-to-oval-def-vuln"
                     test="every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:Rule[exists(xccdf:ident[@system eq 'http://cve.mitre.org'])]/xccdf:check[@system eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5']//xccdf:check-content-ref[not(xcf:is-external-ref($m/cat:catalog, @href) cast as xsd:boolean) and exists(@name)] satisfies exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $n/@href))//oval-def:definition[@id eq $n/@name and @class eq 'vulnerability'])">If an &lt;xccdf:Rule&gt; has an &lt;xccdf:ident&gt; with a CVE and that rule reference an OVAL definition, the definition SHALL have @class 'vulnerability'.|331-2|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-scap-content-ref-comp-once"
                     test="every $m in .//scap:component-ref satisfies count($m/ancestor::scap:data-stream//scap:component-ref[@xlink:href eq $m/@xlink:href]) eq 1">Any component in a data stream collection SHALL be referenced not more than once by any data stream in that collection.|333-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-scap-content-oval-ref-check-content-ref-oval"
                     test="every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:check[@system eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5']//xccdf:check-content-ref[not(xcf:is-external-ref($m/cat:catalog, @href) cast as xsd:boolean)] satisfies exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $n/@href))//oval-def:oval_definitions)">&lt;xccdf:check-content-ref&gt; in an OVAL &lt;xccdf:check&gt; MUST reference an OVAL component. If your content contains external references, SCAPVal will attempt to resolve it in -online mode.|345-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-scap-content-xccdf-check-content-ref-name-not-req"
                     test="every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:check[@system eq 'http://oval.mitre.org/XMLSchema/oval-definitions-5']//xccdf:check-content-ref[not(xcf:is-external-ref($m/cat:catalog, @href) cast as xsd:boolean)] satisfies (not(exists($n/@name)) or exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $n/@href))//oval-def:definition[@id eq $n/@name]))">The following requirements and recommendations apply to the &lt;xccdf:check&gt; element:~~This version of SCAP supports the OVAL and OCIL check systems. Use of these check systems SHALL be restricted as follows:~~OVAL check system~Use of the @name attribute in the &lt;xccdf:check-content-ref&gt; element is OPTIONAL. If present, it MUST reference an OVAL Definition in the designated OVAL source data stream component, otherwise see Section 4.5.2 for information on use of the @multi-check attribute.|346-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-scap-content-ocil-check-content-ref-ocil"
                     test="every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:check[@system eq 'http://scap.nist.gov/schema/ocil/2']//xccdf:check-content-ref[not(xcf:is-external-ref($m/cat:catalog, @href) cast as xsd:boolean)] satisfies exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $n/@href))//ocil:ocil)">The following requirements and recommendations apply to the &lt;xccdf:check&gt; element:~~This version of SCAP supports the OVAL and OCIL check systems. Use of these check systems SHALL be restricted as follows:~~OCIL check system~The @href attribute in the &lt;xccdf:check-content-ref&gt; element MUST reference an OCIL source data stream component using the &lt;ds:component-ref&gt; approach defined above.|348-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-scap-content-ocil-check-content-ref-with-without-name"
                     test="every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:check[@system eq 'http://scap.nist.gov/schema/ocil/2']//xccdf:check-content-ref[not(xcf:is-external-ref($m/cat:catalog, @href) cast as xsd:boolean)] satisfies (not(exists($n/@name)) or exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $n/@href))//ocil:questionnaire[@id eq $n/@name]))">The following requirements and recommendations apply to the &lt;xccdf:check&gt; element:~~This version of SCAP supports the OVAL and OCIL check systems. Use of these check systems SHALL be restricted as follows:~~OCIL check system~Use of the @name attribute in the &lt;xccdf:check-content-ref&gt; element is OPTIONAL. If present, it MUST reference an OCIL questionnaire in the designated OCIL source data stream component, otherwise see Section 4.5.2 for information on use of the @multi-check attribute.|349-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-rule-value-binding-type-3"
                     test="every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:check-export satisfies ( not(matches($n/ancestor::xccdf:Benchmark//xccdf:Value[@id eq $n/@value-id]/@type, '^string$')) or (every $o in $n/following-sibling::xccdf:check-content-ref satisfies matches(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $o/@href))//*[@id eq $n/@export-name]/@datatype, '^(string|evr_string|version|ios_version|fileset_revision|binary)$')))">Values of XCCDF datatype 'string', when bound to OVAL variables, the OVAL variables must be of the following OVAL types: string, evr_string, version, ios_version, fileset_revision, binary|38-3|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-rule-value-binding-type-2"
                     test="every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:check-export satisfies ( not(matches($n/ancestor::xccdf:Benchmark//xccdf:Value[@id eq $n/@value-id]/@type, '^boolean$')) or (every $o in $n/following-sibling::xccdf:check-content-ref satisfies matches(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $o/@href))//*[@id eq $n/@export-name]/@datatype, '^boolean$')))">Values of XCCDF datatype 'boolean', when bound to OVAL variables, the OVAL variables must be the following OVAL type: boolean|38-2|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-rule-value-binding-type-1"
                     test="every $m in ds:checklists/ds:component-ref satisfies every $n in xcf:get-component($m)//xccdf:check-export satisfies ( not(matches($n/ancestor::xccdf:Benchmark//xccdf:Value[@id eq $n/@value-id]/@type, '^number$')) or (every $o in $n/following-sibling::xccdf:check-content-ref satisfies matches(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $o/@href))//*[@id eq $n/@export-name]/@datatype, '^(int|float)$')))">Values of XCCDF datatype 'number', when bound to OVAL variables, the OVAL variables must be of the following OVAL types: int, float|38-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-oval-cpe-inventory"
                     test="every $m in ds:dictionaries/ds:component-ref satisfies every $n in xcf:get-component($m)//cpe-dict:cpe-list/cpe-dict:cpe-item/cpe-dict:check satisfies ($n/@system = 'http://oval.mitre.org/XMLSchema/oval-definitions-5' and exists(xcf:get-component(xcf:get-component-ref($m/cat:catalog, $n/@href))//oval-def:definition[@id = $n]))">For all SCAP &lt;cpe-dict:cpe-item&gt;'s specified the CPE dictionary component of an SCAP datastream that contain a cpe-dict:check element, that cpe-dict:check element SHALL refer to an OVAL inventory definition in the same SCAP data stream|72-1|scap:data-stream <sch:value-of select="@id"/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-general-xccdf-check-content-ref"
                context="xccdf:check-content-ref">
         <sch:assert id="scap-general-xccdf-check-content-ref-name-omit-patch"
                     test="if( exists(ancestor::xccdf:Rule[1][starts-with(@id,'xccdf_') and ends-with(@id,'_rule_security_patches_up_to_date')]) ) then not(exists(@name)) else true()">If a &lt;xccdf:check-content-ref&gt; is in a security patches up-to-date rule then the @name SHALL be omitted from the &lt;xccdf:check-content-ref&gt;. This requirement was removed in SCAP Schematron version 1.1.
|171-1|xccdf:Rule <sch:value-of select="ancestor::xccdf:Rule/@id"/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-general-xccdf-rule" context="xccdf:Rule">
         <sch:assert id="scap-general-xccdf-rule-check-content-ref-req"
                     test="every $m in .//xccdf:check satisfies exists($m/xccdf:check-content-ref)">At least one &lt;xccdf:check-content-ref&gt; element MUST be provided in each &lt;xccdf:check&gt;|175-1|xccdf:Rule <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-rule-cve-cce-cpe"
                     test="exists(xccdf:ident[matches(@system,'^(http://cce.mitre.org|http://cve.mitre.org|http://cpe.mitre.org)$')])">An xccdf:Rule should include an xccdf:ident containing a CVE, CCE, or CPE|251-1|xccdf:Rule <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-rule-ident-cve-cce-cpe-order"
                     test="every $m in xccdf:ident satisfies matches($m/@system,'^(http://cpe.mitre.org|http://cve.mitre.org|http://cce.mitre.org)$') or not(exists($m/following-sibling::xccdf:ident[matches(@system,'^(http://cpe.mitre.org|http://cve.mitre.org|http://cce.mitre.org)$')]))">An &lt;xccdf:ident&gt; element referencing a CVE, CCE, or CPE identifier (using the @system value specified in the 800-126) SHALL be ordered before other &lt;xccdf:ident&gt; elements referencing non-SCAP identifiers.|257-1|xccdf:Rule <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-xccdf-cce-exists"
                     test="every $m in xccdf:ident[matches(@system, '^(http://cce.mitre.org)$')] satisfies exists(document('data/nvdcce-0.1-feed.xml')/nvd-config:nvd/nvd-config:entry[@id eq $m])">All CCE references SHOULD be in the official CCE dictionary.|74-1|xccdf:Rule <sch:value-of select="@id"/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-general-oval-def" context="oval-def:definition">
         <sch:assert id="scap-general-oval-def-rule-compliance-cce"
                     test="if(@class eq 'compliance') then exists(oval-def:metadata/oval-def:reference[matches(@source,'^(http://cce.mitre.org|CCE)$')]) else true()">OVAL definitions of class 'compliance' should include a reference to a CCE, where applicable.|207-1|oval-def:definition <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-oval-def-compliance-extension"
                     test="if(@class eq 'compliance') then every $m in xcf:get-all-parents(ancestor::oval-def:definitions,.) satisfies matches($m/@class,'^(compliance|inventory)$') else true()">For OVAL definitions of @class 'compliance', only definitions of class 'compliance' or 'inventory' can be extended.|208-1|oval-def:definition <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-oval-def-ref-cpe-inventory"
                     test="if(@class eq 'inventory') then exists(oval-def:metadata/oval-def:reference[matches(@source,'^(http://cpe.mitre.org|CPE)$') and (matches(@ref_id,'^[c][pP][eE]:/[AHOaho]?(:[A-Za-z0-9\._\-~%]*){0,6}$') or matches(@ref_id,'^cpe:2\.3:[aho\*-](:(((\?*|\*?)([a-zA-Z0-9\-\._]|(\\[\\\*\?!&#34;#$$%&amp;\(\)\+,/:;&lt;=&gt;@\[\]\^`\{{\|}}~]))+(\?*|\*?))|[\*-])){5}(:(([a-zA-Z]{2,3}(-([a-zA-Z]{2}|[0-9]{3}))?)|[\*-]))(:(((\?*|\*?)([a-zA-Z0-9\-\._]|(\\[\\\*\?!&#34;#$$%&amp;\(\)\+,/:;&lt;=&gt;@\[\]\^`\{{\|}}~]))+(\?*|\*?))|[\*-])){4}$'))]) else true()">OVAL definitions of class 'inventory' should include a reference to a CPE, where applicable.|209-1|oval-def:definition <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-oval-def-inventory-extension"
                     test="if(@class eq 'inventory') then every $m in xcf:get-all-parents(ancestor::oval-def:definitions,.) satisfies matches($m/@class,'^(inventory)$') else true()">For OVAL definitions of @class 'inventory', only definitions of class 'inventory' can be extended.|210-1|oval-def:definition <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-oval-def-patch-ref-cve"
                     test="if( @class eq 'patch' ) then exists(current()//oval-def:reference[matches(@source,'^(CVE|http://cve.mitre.org)$')]) else true()">OVAL patch class MAY reference a CVE. This requirement changed from "SHOULD" to "MAY" in SCAP Schematron version 1.1|211-1|oval-def:definition <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-oval-def-patch-extensions"
                     test="if(@class eq 'patch') then every $m in xcf:get-all-parents(ancestor::oval-def:definitions,.) satisfies matches($m/@class,'^(patch|inventory)$') else true()">For OVAL definitions of @class 'patch', only definitions of class 'patch' or 'inventory' can be extended.|213-1|oval-def:definition <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-oval-def-vulnerability-cve-ref"
                     test="if(@class eq 'vulnerability') then exists(oval-def:metadata/oval-def:reference[matches(@source,'^(http://cve.mitre.org|CVE)$')]) else true()">OVAL definitions of class 'vulnerability' should include a reference to a CVE, where applicable.|214-1|oval-def:definition <sch:value-of select="@id"/>
         </sch:assert>
         <sch:assert id="scap-general-oval-def-vulnerability-extension"
                     test="if(@class eq 'vulnerability') then every $m in xcf:get-all-parents(ancestor::oval-def:definitions,.) satisfies (if( generate-id(current()) ne generate-id($m) ) then matches($m/@class,'^(inventory|vulnerability)$') else true() ) else true()">For OVAL definitions of @class 'vulnerability', only definitions of class 'inventory' or 'vulnerability' can be extended.|215-1|oval-def:definition <sch:value-of select="@id"/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-general-oval-generator" context="oval-def:generator">
         <sch:assert id="scap-general-oval-generator-version"
                     test="matches(oval-com:schema_version,'^5\.(3|4|5|6|7|8|9|10)$')">OVAL documents must be written in one of the following versions: 5.3, 5.4, 5.5, 5.6, 5.7, 5.8, 5.9, 5.10|216-1</sch:assert>
      </sch:rule>
      <sch:rule id="scap-general-signature-sig" context="dsig:Signature">
         <sch:assert id="scap-general-signature-sig-one-ds-ref"
                     test="every $m in dsig:SignedInfo/dsig:Reference satisfies ((not(exists(ancestor::ds:data-stream-collection[1]/ds:data-stream[concat('#',@id) eq $m/@URI]))) or (every $n in $m/preceding-sibling::dsig:Reference satisfies not(exists(ancestor::ds:data-stream-collection[1]/ds:data-stream[concat('#',@id) eq $n/@URI]))))">Each &lt;dsig:Signature&gt; element MUST sign only one data stream|282-1|dsig:Signature <sch:value-of select="@Id"/>
         </sch:assert>
         <sch:assert id="scap-general-signature-sig-local-refs-req"
                     test="every $m in ancestor::ds:data-stream-collection[1]/ds:data-stream[concat('#',@id) eq current()/dsig:SignedInfo/dsig:Reference[1]/@URI]//ds:component-ref[starts-with(@xlink:href,'#')] satisfies exists(dsig:Object/dsig:Manifest/dsig:Reference[@URI eq $m/@xlink:href])">The &lt;dsig:Manifest&gt; MUST have a &lt;dsig:Reference&gt; for each local component referenced by the data stream being signed.|284-2|dsig:Signature <sch:value-of select="@Id"/>
         </sch:assert>
         <sch:assert id="scap-general-signature-sig-manifest-req"
                     test="exists(dsig:Object/dsig:Manifest)">A &lt;dsig:Manifest&gt; MUST be included in the &lt;dsig:Signature&gt; as a &lt;dsig:Object&gt;|284-1|dsig:Signature <sch:value-of select="@Id"/>
         </sch:assert>
         <sch:assert id="scap-general-signature-sig-tmsad"
                     test="exists(dsig:Object/dsig:SignatureProperties/dsig:SignatureProperty/tmsad:signature-info)">A &lt;dsig:SignatureProperties&gt; MUST be included in the &lt;dsig:Signature&gt; as a &lt;dsig:Object&gt; with a dsig:SignatureProperty populated with tmsad:signature-info|285-1|dsig:Signature <sch:value-of select="@Id"/>
         </sch:assert>
         <sch:assert id="scap-general-signature-sig-first-ref-ds"
                     test="exists(ancestor::ds:data-stream-collection[1]/ds:data-stream[concat('#',@id) eq current()/dsig:SignedInfo/dsig:Reference[1]/@URI])">The first &lt;dsig:Reference&gt; element in a &lt;dsig:Signature&gt; element MUST be to the &lt;ds:data-stream&gt; element being signed. The &lt;ds:data-stream&gt; element MUST be referenced in the @URI attribute using "#" + @Id of the &lt;ds:data-stream&gt;|286-1|dsig:Signature <sch:value-of select="@Id"/>
         </sch:assert>
         <sch:assert id="scap-general-signature-sig-ref-sig-prop"
                     test="exists(dsig:Object/dsig:SignatureProperties[concat('#',@Id) eq current()/dsig:SignedInfo/dsig:Reference[2]/@URI])">The second &lt;dsig:Reference&gt; element in a &lt;dsig:Signature&gt; element MUST be to the &lt;dsig:SignatureProperties&gt; element captured in a &lt;dsig:Object&gt; element within the &lt;dsig:Signature&gt; element. The &lt;dsig:SignatureProperties&gt; element MUST be referenced in the @URI attribute using "#" + @Id of the&lt;dsig:SignatureProperties&gt; element. |287-1|dsig:Signature <sch:value-of select="@Id"/>
         </sch:assert>
         <sch:assert id="scap-general-signature-sig-third-ref-manifest"
                     test="exists(dsig:Object/dsig:Manifest[concat('#',@Id) eq current()/dsig:SignedInfo/dsig:Reference[3]/@URI])">The third &lt;dsig:Reference&gt; element MUST be to the &lt;dsig:Manifest&gt; element captured in a &lt;dsig:Object&gt; element with the &lt;dsig:Signature&gt; element. The &lt;dsig:Manifest&gt; element MUST be referenced in the @URI attribute using "#" + @Id attribute of the &lt;dsig:Manifest&gt;|288-1|dsig:Signature <sch:value-of select="@Id"/>
         </sch:assert>
         <sch:assert id="scap-general-signature-sig-key-info" test="exists(dsig:KeyInfo)">Key information SHOULD be provided on the &lt;dsig:Signature&gt;.|290-1|dsig:Signature <sch:value-of select="@Id"/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-general-xccdf-version" context="xccdf:version">
         <sch:assert id="scap-general-xccdf-version-time-attribute-req" test="exists(@time)">The @time attribute of the &lt;xccdf:version&gt; element SHOULD be used for a timestamp of when the benchmark was defined.|3-2</sch:assert>
         <sch:assert id="scap-general-xccdf-version-update-req" test="exists(@update)">@update on &lt;xccdf:version&gt; SHOULD be specified|341-1</sch:assert>
      </sch:rule>
      <sch:rule id="scap-general-xccdf-status-rule-value-date" context="xccdf:status">
         <sch:assert id="scap-general-xccdf-status-rule-value-date-1"
                     test=". eq 'draft' or . eq 'accepted'">The &lt;xccdf:status&gt; element SHALL have value 'draft' or 'accepted'|5-1</sch:assert>
         <sch:assert id="scap-general-xccdf-status-rule-value-date-2" test="@date ne ''">The "date" attribute of the &lt;xccdf:status&gt; element SHALL be populated with the date of the last status change.|5-2</sch:assert>
      </sch:rule>
  </sch:pattern>
  <sch:pattern id="scap-additional-rules">
      <sch:rule id="scap-unused-oval-rule" context="oval-def:definition">
         <sch:assert flag="WARNING"
                     test="if(exists(//scap:xccdf-content)) then exists(ancestor::scap:check-system-content[@content-type eq 'OVAL_PATCH']) or exists(//xccdf:check-content-ref[@href eq current()/ancestor::scap:check-system-content/@id and (not(@name) or @name eq current()/@id)]) or exists(current()/ancestor::oval-def:oval_definitions//oval-def:extend_definition[@definition_ref eq current()/@id]) or exists(//cpe-dict:check[@href eq current()/ancestor::scap:check-system-content/@id and . eq current()/@id]) else true()"
                     id="scap-unused-oval-assert">Unused OVAL definitions exist|A15|oval-def:definition <sch:value-of select="@id"/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-cce-check-rule-1" context="xccdf:ident">
         <sch:assert flag="WARNING"
                     test="if(@system eq 'http://cce.mitre.org' or @system eq 'CCE') then . ne '' else true()"
                     id="scap-cce-check-assert-1">CCE number is expected, but missing as a reference|A16|xccdf:Rule <sch:value-of select="ancestor::xccdf:Rule/@id"/>
         </sch:assert>
         <sch:assert flag="ERROR"
                     test="if(@system eq 'http://cce.mitre.org' or @system eq 'CCE') then matches(., '^CCE-\d+-\d$') else true()"
                     id="scap-cce-check-assert-2">CCE number is in an invalid format or the check-digit does not match. It should be of format CCE-XXXX-X or CCE-XXXXX-X where each X is a digit, and the final X is a check-digit.|A17|<sch:value-of select="."/>
         </sch:assert>
         <sch:assert flag="ERROR"
                     test="if((@system eq 'http://cce.mitre.org' or @system eq 'CCE') and matches(., '^CCE-\d+-\d$')) then (sum(for $j in (for $i in reverse(string-to-codepoints(concat(substring(.,5,string-length(.)-6),substring(.,string-length(.),1))))[position() mod 2 = 0] return ($i - 48) * 2, for $i in reverse(string-to-codepoints(concat(substring(.,5,string-length(.)-6),substring(.,string-length(.),1))))[position() mod 2 = 1] return ($i - 48)) return ($j mod 10, $j idiv 10)) mod 10) eq 0 else true()"
                     id="scap-cce-check-assert-3">CCE number is in an invalid format or the check-digit does not match. It should be of format CCE-XXXX-X or CCE-XXXXX-X where each X is a digit, and the final X is a check-digit.|A17|<sch:value-of select="."/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-cce-check-rule-2" context="oval-def:reference">
         <sch:assert flag="WARNING"
                     test="if(@source eq 'http://cce.mitre.org' or @source eq 'CCE') then @ref_id ne '' else true()"
                     id="scap-cce-check-assert-5">CCE number is expected, but missing as a reference|A16|oval-def:definition <sch:value-of select="ancestor::oval-def:definition/@id"/>
         </sch:assert>
         <sch:assert flag="ERROR"
                     test="if(@source eq 'http://cce.mitre.org' or @source eq 'CCE') then matches(@ref_id, '^CCE-\d+-\d$') else true()"
                     id="scap-cce-check-assert-6">CCE number is in an invalid format or the check-digit does not match. It should be of format CCE-XXXX-X or CCE-XXXXX-X where each X is a digit, and the final X is a check-digit.|A17|<sch:value-of select="@ref_id"/>
         </sch:assert>
         <sch:assert flag="ERROR"
                     test="if((@source eq 'http://cce.mitre.org' or @source eq 'CCE') and matches(@ref_id, '^CCE-\d+-\d$')) then (sum(for $j in (for $i in reverse(string-to-codepoints(concat(substring(@ref_id,5,string-length(@ref_id)-6),substring(@ref_id,string-length(@ref_id),1))))[position() mod 2 = 0] return ($i - 48) * 2, for $i in reverse(string-to-codepoints(concat(substring(@ref_id,5,string-length(@ref_id)-6),substring(@ref_id,string-length(@ref_id),1))))[position() mod 2 = 1] return ($i - 48)) return ($j mod 10, $j idiv 10)) mod 10) eq 0 else true()"
                     id="scap-cce-check-assert-7">CCE number is in an invalid format or the check-digit does not match. It should be of format CCE-XXXX-X or CCE-XXXXX-X where each X is a digit, and the final X is a check-digit.|A17|<sch:value-of select="@ref_id"/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-check-system-content-match-rule"
                context="scap:check-system-content">
         <sch:assert flag="ERROR"
                     test="if(matches(@content-type,'^(OVAL_COMPLIANCE|OVAL_PATCH|CPE_INVENTORY|OVAL_VULNERABILITY)$')) then exists(oval-def:oval_definitions) else true()"
                     id="scap-check-system-content-match-assert-1">The attribute @content-type on &lt;scap:check-system-content&gt; must match the content as such: OVAL_COMPLIANCE, OVAL_PATCH, CPE_INVENTORY, OVAL_VULNERABILITY must contain an &lt;oval-def:oval_definitions&gt; element; OCIL_QUESTIONS must contain an &lt;ocil:ocil&gt; element.|A18</sch:assert>
         <sch:assert flag="ERROR"
                     test="if(matches(@content-type,'^(OCIL_QUESTIONS)$')) then exists(ocil:ocil) else true()"
                     id="scap-check-system-content-match-assert-2">The attribute @content-type on &lt;scap:check-system-content&gt; must match the content as such: OVAL_COMPLIANCE, OVAL_PATCH, CPE_INVENTORY, OVAL_VULNERABILITY must contain an &lt;oval-def:oval_definitions&gt; element; OCIL_QUESTIONS must contain an &lt;ocil:ocil&gt; element.|A18</sch:assert>
      </sch:rule>
      <!--        
        <sch:rule id="scap-xccdf-profile-check-rule" context="xccdf:Benchmark">
        <sch:assert flag="ERROR"
        test="if($profile ne '') then exists(current()//xccdf:Profile[@id eq $profile]) else true()"
        id="scap-xccdf-profile-check-asset">A20|xccdf:Benchmark <sch:value-of select="@id"/></sch:assert>
        </sch:rule>
    -->
      <sch:rule id="scap-oval-tests" context="oval-def:tests/*">
         <sch:assert flag="INFO"
                     test="exists(document(concat('data','/validation_program_oval_test_types.xml'))/test_types/test_type[@namespace eq namespace-uri(current()) and @name eq local-name(current())])"
                     id="scap-oval-tests-validation-program-test-types">The OVAL test type is not checked in the NIST SCAP Validation Program.|A21|OVAL test <sch:value-of select="@id"/>
         </sch:assert>
      </sch:rule>
      <sch:rule id="scap-collection" context="scap:data-stream-collection">
         <sch:assert flag="WARNING"
                     test="function-available('java:isEqualOrSuperset')"
                     id="scap-collection-java-functions">A custom XPath function is not available|A22</sch:assert>
      </sch:rule>
  </sch:pattern>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-all-profile-parents">
      <xsl:param name="doc"/>
      <xsl:param name="node"/>
      <xsl:sequence select="$node"/>
      <xsl:if test="exists($node/@extends)">
         <xsl:sequence select="xcf:get-all-profile-parents($doc,$doc//xccdf:Benchmark//xccdf:Profile[@id eq $node/@extends])"/>
      </xsl:if>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-component">
      <xsl:param name="component-ref"/>
      <xsl:sequence select="$component-ref/ancestor::ds:data-stream-collection//ds:component[@id eq substring($component-ref/@xlink:href,2)]"/>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 xmlns="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-all-def-children">
      <xsl:param name="doc"/>
      <xsl:param name="node"/>
      <xsl:sequence select="$node"/>
      <xsl:for-each select="$doc//oval-def:extend_definition[@definition_ref eq $node/@id]/ancestor::oval-def:definition">
         <xsl:sequence select="xcf:get-all-def-children($doc,current())"/>
      </xsl:for-each>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:ident-mapping">
      <xsl:param name="in-string"/>
      <xsl:choose>
         <xsl:when test="$in-string eq 'http://cce.mitre.org'">
            <xsl:value-of select="string('^(CCE|http://cce.mitre.org)$')"/>
         </xsl:when>
         <xsl:when test="$in-string eq 'http://cve.mitre.org'">
            <xsl:value-of select="string('^(CVE|http://cve.mitre.org)$')"/>
         </xsl:when>
         <xsl:when test="$in-string eq 'http://cpe.mitre.org'">
            <xsl:value-of select="string('^(CPE|http://cpe.mitre.org)$')"/>
         </xsl:when>
      </xsl:choose>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-all-parents">
      <xsl:param name="doc"/>
      <xsl:param name="node"/>
      <xsl:sequence select="$node"/>
      <xsl:for-each select="$node//oval-def:extend_definition">
         <xsl:sequence select="xcf:get-all-parents($doc,ancestor::oval-def:oval_definitions//*[@id eq current()/@definition_ref])"/>
      </xsl:for-each>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-ocil-var-ref">
      <xsl:param name="ocil_questionnaire"/>
      <xsl:variable name="initialSet">
         <xsl:for-each select="$ocil_questionnaire/ocil:actions/ocil:test_action_ref">
            <xsl:sequence select="ancestor::ocil:ocil/ocil:test_actions/ocil:numeric_question_test_action[@id eq current()]/ocil:when_equals[@var_ref]"/>
            <xsl:sequence select="ancestor::ocil:ocil/ocil:test_actions/ocil:string_question_test_action[@id eq current()]/ocil:when_pattern/ocil:pattern[@var_ref]"/>
            <xsl:sequence select="ancestor::ocil:ocil/ocil:test_actions/ocil:numeric_question_test_action[@id eq current()]/ocil:when_range/ocil:range/ocil:min[@var_ref]"/>
            <xsl:sequence select="ancestor::ocil:ocil/ocil:test_actions/ocil:numeric_question_test_action[@id eq current()]/ocil:when_range/ocil:range/ocil:max[@var_ref]"/>
            <xsl:for-each select="ancestor::ocil:ocil/ocil:test_actions/*[@id eq current()]">
               <xsl:sequence select="ancestor::ocil:ocil/ocil:questions/ocil:choice_question[@id eq current()/@question_ref]/ocil:choice[@var_ref]"/>
               <xsl:for-each select="ancestor::ocil:ocil/ocil:questions/ocil:choice_question[@id eq current()/@question_ref]/ocil:choice_group_ref">
                  <xsl:sequence select="ancestor::ocil:questions/ocil:choice_group[@id eq current()]/ocil:choice[@var_ref]"/>
               </xsl:for-each>
            </xsl:for-each>
         </xsl:for-each>
      </xsl:variable>
      <xsl:for-each select="$initialSet/*">
         <xsl:sequence select="xcf:pass-ocil-var-ref($ocil_questionnaire,current())"/>
      </xsl:for-each>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-component-ref">
      <xsl:param name="catalog"/>
      <xsl:param name="uri"/>
      <xsl:variable name="component-ref-uri"
                    select="xcf:resolve-in-catalog($catalog/*[1],$uri)"/>
      <xsl:if test="$component-ref-uri ne ''">
         <xsl:sequence select="$catalog/ancestor::ds:data-stream//ds:component-ref[@id eq substring($component-ref-uri,2)]"/>
      </xsl:if>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:pass-ocil-var-ref">
      <xsl:param name="ocil_questionnaire"/>
      <xsl:param name="var_ref"/>
      <xsl:sequence select="$var_ref"/>
      <xsl:for-each select="$ocil_questionnaire/ancestor::ocil:ocil/ocil:variables/ocil:local_variable[@id eq $var_ref/@var_ref]/ocil:set/ocil:when_range/ocil:min[@var_ref]">
         <xsl:sequence select="xcf:pass-ocil-var-ref($ocil_questionnaire,current())"/>
      </xsl:for-each>
      <xsl:for-each select="$ocil_questionnaire/ancestor::ocil:ocil/ocil:variables/ocil:local_variable[@id eq $var_ref/@var_ref]/ocil:set/ocil:when_range/ocil:max[@var_ref]">
         <xsl:sequence select="xcf:pass-ocil-var-ref($ocil_questionnaire,current())"/>
      </xsl:for-each>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:resolve-in-catalog">
      <xsl:param name="resolver-node"/>
      <xsl:param name="uri"/>
      <xsl:choose>
         <xsl:when test="starts-with($uri,'#')">
            <xsl:value-of select="$uri"/>
         </xsl:when>
         <xsl:when test="exists($resolver-node)">
            <xsl:choose>
               <xsl:when test="$resolver-node/local-name() eq 'uri'">
                  <xsl:choose>
                     <xsl:when test="$resolver-node/@name eq $uri">
                        <xsl:value-of select="$resolver-node/@uri"/>
                     </xsl:when>
                     <xsl:otherwise>
                        <xsl:value-of select="xcf:resolve-in-catalog($resolver-node/following-sibling::*[1], $uri)"/>
                     </xsl:otherwise>
                  </xsl:choose>
               </xsl:when>
               <xsl:when test="$resolver-node/local-name() eq 'rewriteURI'">
                  <xsl:choose>
                     <xsl:when test="starts-with($uri,$resolver-node/@uriStartString)">
                        <xsl:value-of select="concat($resolver-node/@rewritePrefix,substring($uri,string-length($resolver-node/@uriStartString)+1))"/>
                     </xsl:when>
                     <xsl:otherwise>
                        <xsl:value-of select="xcf:resolve-in-catalog($resolver-node/following-sibling::*[1], $uri)"/>
                     </xsl:otherwise>
                  </xsl:choose>
               </xsl:when>
            </xsl:choose>
         </xsl:when>
      </xsl:choose>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 xmlns="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-all-external-vars">
      <xsl:param name="doc"/>
      <xsl:param name="node"/>
      <xsl:sequence select="$doc//oval-def:external_variable[@id eq $node/@var_ref]"/>
      <xsl:for-each select="$doc//*[@id eq $node/@var_ref]//*[@var_ref]">
         <xsl:sequence select="xcf:get-all-external-vars($doc,current())"/>
      </xsl:for-each>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:is-external-ref">
      <xsl:param name="catalog"/>
      <xsl:param name="uri"/>
      <xsl:variable name="comp-ref" select="xcf:get-component-ref($catalog,$uri)"/>
      <xsl:choose>
         <xsl:when test="exists($comp-ref)">
            <xsl:value-of select="not(starts-with($comp-ref/@xlink:href,'#'))"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="false()"/>
         </xsl:otherwise>
      </xsl:choose>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-all-group-parents">
      <xsl:param name="doc"/>
      <xsl:param name="node"/>
      <xsl:sequence select="$node"/>
      <xsl:if test="exists($node/@extends)">
         <xsl:sequence select="xcf:get-all-group-parents($doc,$doc//xccdf:Benchmark//xccdf:Group[@id eq $node/@extends])"/>
      </xsl:if>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-locator-prefix">
      <xsl:param name="name"/>
      <xsl:variable name="subName"
                    select="substring($name,1,string-length($name) - string-length(tokenize($name,'-')[last()]) - 1)"/>
      <xsl:choose>
         <xsl:when test="ends-with($subName,'cpe')">
            <xsl:value-of select="xcf:get-locator-prefix($subName)"/>
         </xsl:when>
         <xsl:otherwise>
            <xsl:value-of select="tokenize($subName,'/')[last()]"/>
         </xsl:otherwise>
      </xsl:choose>
  </xsl:function>
  <xsl:function xmlns:xcf="nist:scap:xslt:function"
                 xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
                 name="xcf:get-locator-prefix-res">
      <xsl:param name="name"/>
      <xsl:variable name="subName"
                    select="substring($name,1,string-length($name) - string-length(tokenize($name,'-')[last()]) - 1)"/>
      <xsl:value-of select="xcf:get-locator-prefix($subName)"/>
  </xsl:function>
</sch:schema>
